## org.eclipse.emf.codegen.ecore.genmodel
Interface GenPackage

All Superinterfaces:
  EObject, GenBase, Notifier

All Known Implementing Classes:
  GenPackageImpl

    public interface GenPackage

extends GenBase

A representation of the model object 'Gen Package'.

The following features are supported:

- `Prefix`
- `Base Package`
- `Resource`
- `Disposable Provider Factory`
- `Adapter Factory`
- `Load Initialization`
- `Interface Package Suffix`
- `Meta Data Package Suffix`
- `Class Package Suffix`
- `Utility Package Suffix`
- `Provider Package Suffix`
- `Presentation Package Suffix`
- `Tests Package Suffix`
- `Generate Example Class`
- `Literals Interface`
- `Data Type Converters`
- `Multiple Editor Pages`
- `Generate Model Wizard`
- `Extensible Provider Factory`
- `Child Creation Extenders`
- `Content Type Identifier`
- `File Extensions`
- `Ecore Package`
- `Gen Model`
- `Gen Enums`
- `Gen Data Types`
- `Gen Classes`
- `Nested Gen Packages`
- `Gen Classifiers`

See Also:
  `GenModelPackage.getGenPackage()`

Nested Class Summary
`static class` `GenPackage.AnnotationReferenceData`

Method Summary
`void` `clearCache()`
`void` `generateSchema()` Deprecated. In EMF 2.2, schema generation is properly done via a model exporter. This method will be removed after 2.2.
`java.lang.String` `getActionBarContributorClassName()`
`java.util.List<GenPackage>` `getAdapterDelegatePackages()`
`java.util.List<GenClass>` `getAdapterDelegateSuperClasses()`
`java.lang.String` `getAdapterFactoryClassName()`
`java.lang.String` `getAdapterFactoryDelegateName(GenPackage genDelegate)`
`java.util.List<EAnnotation>` `getAllAnnotations()`
`java.util.List<GenDataType>` `getAllGenDataTypes()`
`java.util.List<GenFeature>` `getAllGenFeatures()`
`java.util.List<EAnnotation>` `getAllNestedAnnotations(EAnnotation eAnnotation)`
`java.util.List<GenClass>` `getAllSwitchGenClasses()`
`java.util.List<GenPackage>` `getAllValidatorBaseGenPackages()`
`java.lang.String` `getAnnotatedModelElementAccessor(EAnnotation eAnnotation)`
`java.lang.String` `getAnnotationSourceIdentifier(java.lang.String annotationSource)`
`java.util.List<java.lang.String>` `getAnnotationSources()`
`java.lang.String` `getBasePackage()` Returns the value of the 'Base Package' attribute
`java.lang.String` `getBasicPackageName()` Returns the name of the single package class generated when interfaces are suppressed.
`java.lang.String` `getChildCreationExtenderName(GenPackage genPackage)`
`java.lang.String` `getClassifierID(GenClassifier genClassifier)`
`int` `getClassifierValue(GenClassifier genClassifier)`
`java.lang.String` `getClassPackageName()`
`java.lang.String` `getClassPackageSuffix()` Returns the value of the 'Class Package Suffix' attribute.
`java.lang.String` `getClassUniqueName(GenClass genClass)`
`java.lang.String` `getContentTypeIdentifier()` Returns the value of the 'Content Type Identifier' attribute
`GenClass` `getDocumentRoot()`
`EPackage` `getEcorePackage()` Returns the value of the 'Ecore Package' reference
`java.lang.String` `getEditorClassName()`
`java.lang.String` `getEditorPluginClassName()`
`java.lang.String` `getEditPluginClassName()`
`java.lang.String` `getExampleClassName()`
`java.util.Map<GenPackage,java.util.Map<GenClass,java.util.List<GenClass.ChildCreationData>>>` `getExtendedChildCreationData()` Returns a nested map structure describing the child creation extensions that this package provides to other packages.
`java.lang.String` `getFactoryClassName()`
`java.lang.String` `getFactoryInstanceName()`
`java.lang.String` `getFactoryInterfaceName()`
`java.lang.String` `getFactoryName()` Returns the name of the single factory class generated when interfaces are suppressed.
`java.lang.String` `getFileExtension()` Returns the first `file extension` in the comma-separated list.
`java.lang.String` `getFileExtensions()` Returns the value of the 'File Extensions' attribute
`EList<GenClass>` `getGenClasses()` Returns the value of the 'Gen Classes' containment reference list.
`EList<GenClassifier>` `getGenClassifiers()` Returns the value of the 'Gen Classifiers' reference list.
`EList<GenDataType>` `getGenDataTypes()` Returns the value of the 'Gen Data Types' containment reference list.
`EList<GenEnum>` `getGenEnums()` Returns the value of the 'Gen Enums' containment reference list.
`GenModel` `getGenModel()` Returns the value of the 'Gen Model' container reference.
`java.lang.String` `getImportedActionBarContributorClassName()`
`java.lang.String` `getImportedAdapterFactoryClassName()`
`java.lang.String` `getImportedEditorClassName()`
`java.lang.String` `getImportedEditorPluginClassName()`
`java.lang.String` `getImportedEditPluginClassName()`
`java.lang.String` `getImportedFactoryClassName()`
`java.lang.String` `getImportedFactoryInterfaceName()`
`java.lang.String` `getImportedItemProviderAdapterFactoryClassName()`
`java.lang.String` `getImportedModelWizardClassName()`
`java.lang.String` `getImportedPackageClassName()`
`java.lang.String` `getImportedPackageInterfaceName()`
`java.lang.String` `getImportedResourceBaseClassName()`
`java.lang.String` `getImportedResourceClassName()`
`java.lang.String` `getImportedResourceFactoryBaseClassName()`
`java.lang.String` `getImportedResourceFactoryClassName()`
`java.lang.String` `getImportedTestSuiteClassName()`
`java.lang.String` `getImportedValidatorClassName()`
`java.lang.String` `getImportedXMLProcessorBaseClassName()`
`java.lang.String` `getInterfacePackageName()`
`java.lang.String` `getInterfacePackageSuffix()` Returns the value of the 'Interface Package Suffix' attribute.
`java.lang.String` `getItemProviderAdapterFactoryClassName()`
`java.util.List<java.lang.String>` `getJavaLangConflicts()`
`int` `getLocalClassifierIndex(GenClassifier genClassifier)`
`java.lang.String` `getMetaDataPackageSuffix()` Returns the value of the 'Meta Data Package Suffix' attribute.
`java.lang.String` `getModelIconFileName()`
`java.lang.String` `getModelInfo()`
`java.lang.String` `getModelWizardClassName()`
`java.lang.String` `getModelWizardIconFileName()`
`EList<GenPackage>` `getNestedGenPackages()` Returns the value of the 'Nested Gen Packages' containment reference list.
`java.lang.String` `getNSName()`
`java.lang.String` `getNSURI()`
`java.util.List<GenClass>` `getOrderedGenClasses()` Returns the list of GenClasses in the GenPackage, ordered such that a class always follows all of the classes it extends.
`java.util.List<GenClassifier>` `getOrderedGenClassifiers()`
`java.util.List<GenPackage>` `getPackageBuildInterDependencies()`
`java.lang.String` `getPackageClassName()`
`java.util.List<GenPackage>` `getPackageInitializationDependencies()`
`java.lang.String` `getPackageInstanceVariable(GenPackage genPackage)`
`java.util.List<GenPackage>` `getPackageInterDependencies()`
`java.lang.String` `getPackageInterfaceName()`
`java.util.List<GenPackage>` `getPackageLoadInterDependencies()`
`java.lang.String` `getPackageName()`
`java.util.List<GenPackage>` `getPackageSimpleDependencies()`
`java.lang.String` `getPrefix()` Returns the value of the 'Prefix' attribute
`java.lang.String` `getPresentationPackageName()`
`java.lang.String` `getPresentationPackageSuffix()` Returns the value of the 'Presentation Package Suffix' attribute.
`java.lang.String` `getProviderPackageName()`
`java.lang.String` `getProviderPackageSuffix()` Returns the value of the 'Provider Package Suffix' attribute.
`java.util.List<java.lang.String>` `getProviderSupportedTypes()`
`java.lang.String` `getQualifiedActionBarContributorClassName()`
`java.lang.String` `getQualifiedAdapterFactoryClassName()`
`java.lang.String` `getQualifiedContentTypeIdentifier()` Returns the qualified content type identifier.
`java.lang.String` `getQualifiedEditorClassName()`
`java.lang.String` `getQualifiedEditorPluginClassName()`
`java.lang.String` `getQualifiedEditPluginClassName()`
`java.lang.String` `getQualifiedEFactoryInstanceAccessor()`
`java.lang.String` `getQualifiedEFactoryInternalInstanceAccessor()`
`java.lang.String` `getQualifiedEffectiveResourceFactoryClassName()` Returns the package's `resource factory class name`, or the framework's default XMI resource factory class name if no `resource` will be generated for the package.
`java.lang.String` `getQualifiedExampleClassName()`
`java.lang.String` `getQualifiedFactoryClassName()`
`java.lang.String` `getQualifiedFactoryInstanceAccessor()`
`java.lang.String` `getQualifiedFactoryInterfaceName()`
`java.lang.String` `getQualifiedItemProviderAdapterFactoryClassName()`
`java.lang.String` `getQualifiedModelWizardClassName()`
`java.lang.String` `getQualifiedPackageClassName()`
`java.lang.String` `getQualifiedPackageInterfaceName()`
`java.lang.String` `getQualifiedPackageName()`
`java.lang.String` `getQualifiedResourceClassName()`
`java.lang.String` `getQualifiedResourceFactoryClassName()`
`java.lang.String` `getQualifiedSwitchClassName()`
`java.lang.String` `getQualifiedTestSuiteClassName()`
`java.lang.String` `getQualifiedValidatorClassName()`
`java.lang.String` `getQualifiedXMLProcessorClassName()`
`java.util.List<GenPackage.AnnotationReferenceData>` `getReferenceData(EAnnotation eAnnotation)`
`java.lang.String` `getReflectionClassPackageName()`
`java.lang.String` `getReflectionPackageName()`
`GenResourceKind` `getResource()` Returns the value of the 'Resource' attribute.
`java.lang.String` `getResourceClassName()`
`java.lang.String` `getResourceFactoryClassName()`
`GenClass` `getRootClass()`
`GenFeature` `getRootFeature()`
`GenPackage` `getRootGenPackage()` Returns the top-most GenPackage-typed container for which hasClassifiers() is true, which may be this GenPackage, itself.
`java.lang.String` `getSerializedPackageFilename()`
`java.util.List<GenPackage>` `getSubGenPackages()` Returns a list of those nestedGenPackages for which hasClassifiers() is true.
`GenPackage` `getSuperGenPackage()` Returns the closest GenPackage-typed container for which hasClassifiers() is true, or null if there is none.
`java.lang.String` `getSwitchClassName()`
`java.lang.String` `getTestsPackageName()`
`java.lang.String` `getTestsPackageSuffix()` Returns the value of the 'Tests Package Suffix' attribute.
`java.lang.String` `getTestSuiteClassName()`
`java.lang.String` `getUncapAdapterFactoryClassName()`
`java.lang.String` `getUncapAdapterFactoryDelegateName(GenPackage genDelegate)`
`java.lang.String` `getUncapFactoryInterfaceName()` Deprecated. Use `getUncapFactoryName()`, which won't change with the interface name pattern, instead.
`java.lang.String` `getUncapFactoryName()`
`java.lang.String` `getUncapPackageInterfaceName()` Deprecated. Use `getUncapFactoryName()`, which won't change with the interface name pattern, instead.
`java.lang.String` `getUncapPackageName()`
`java.lang.String` `getUtilitiesPackageName()`
`java.lang.String` `getUtilityPackageSuffix()` Returns the value of the 'Utility Package Suffix' attribute.
`java.lang.String` `getValidatorClassName()`
`java.lang.String` `getValidatorPackageUniqueSafeName(GenPackage genPackage)`
`java.lang.String` `getXMLProcessorClassName()`
`boolean` `hasClassifiers()`
`boolean` `hasClassifiers(boolean traverseNestedPackages)`
`boolean` `hasConcreteClasses()`
`boolean` `hasConstraints()`
`boolean` `hasDocumentRoot()`
`boolean` `hasExtendedMetaData()`
`boolean` `hasInterfaceImplConflict()`
`boolean` `hasJavaLangConflict()`
`boolean` `hasStatefulProvider()`
`boolean` `hasTargetNamespace()`
`boolean` `hasTests()`
`boolean` `hasXMLMap()`
`void` `initialize(EPackage ePackage)`
`boolean` `isAdapterFactory()` Returns the value of the 'Adapter Factory' attribute.
`boolean` `isChildCreationExtenders()` Returns the value of the 'Child Creation Extenders' attribute
`boolean` `isContentType()` Returns whether the package should define a content type.
`boolean` `isDataTypeConverters()` Returns the value of the 'Data Type Converters' attribute
`boolean` `isDisposableProviderFactory()` Returns the value of the 'Disposable Provider Factory' attribute
`boolean` `isEcorePackage()`
`boolean` `isExtensibleProviderFactory()` Returns the value of the 'Extensible Provider Factory' attribute
`boolean` `isGenerateExampleClass()` Returns the value of the 'Generate Example Class' attribute.
`boolean` `isGenerateModelWizard()` Returns the value of the 'Generate Model Wizard' attribute.
`boolean` `isLiteralsInterface()` Returns the value of the 'Literals Interface' attribute.
`boolean` `isLoadedInitialization()` Returns true if this package's root, which may be itself, requires, or has a subpackage that requires, load initialization.
`boolean` `isLoadingInitialization()` Returns true if this is a root package that requires, or has a direct or indirect subpackage that requires, load initialization.
`boolean` `isLoadInitialization()` Returns the value of the 'Load Initialization' attribute
`boolean` `isMultipleEditorPages()` Returns the value of the 'Multiple Editor Pages' attribute.
`boolean` `isMultipleFileExtensions()` Returns whether the model supports multiple file extensions, based both on the specified `extensions` and the use of a `content type`.
`boolean` `isXMIResource()` Returns whether the package's `resource` produces an XMI serialization.
`void` `prepareCache()`
`boolean` `reconcile(GenPackage oldGenPackageVersion)`
`void` `setAdapterFactory(boolean value)` Sets the value of the '`Adapter Factory`' attribute
`void` `setBasePackage(java.lang.String value)` Sets the value of the '`Base Package`' attribute
`void` `setChildCreationExtenders(boolean value)` Sets the value of the '`Child Creation Extenders`' attribute
`void` `setClassPackageSuffix(java.lang.String value)` Sets the value of the '`Class Package Suffix`' attribute
`void` `setContentTypeIdentifier(java.lang.String value)` Sets the value of the '`Content Type Identifier`' attribute
`void` `setDataTypeConverters(boolean value)` Sets the value of the '`Data Type Converters`' attribute
`void` `setDisposableProviderFactory(boolean value)` Sets the value of the '`Disposable Provider Factory`' attribute
`void` `setEcorePackage(EPackage value)` Sets the value of the '`Ecore Package`' reference
`void` `setExtensibleProviderFactory(boolean value)` Sets the value of the '`Extensible Provider Factory`' attribute
`void` `setFileExtensions(java.lang.String value)` Sets the value of the '`File Extensions`' attribute
`void` `setGenerateExampleClass(boolean value)` Sets the value of the '`Generate Example Class`' attribute
`void` `setGenerateModelWizard(boolean value)` Sets the value of the '`Generate Model Wizard`' attribute
`void` `setGenModel(GenModel value)` Sets the value of the '`Gen Model`' container reference
`void` `setInterfacePackageSuffix(java.lang.String value)` Sets the value of the '`Interface Package Suffix`' attribute
`void` `setLiteralsInterface(boolean value)` Sets the value of the '`Literals Interface`' attribute
`void` `setLoadInitialization(boolean value)` Sets the value of the '`Load Initialization`' attribute
`void` `setMetaDataPackageSuffix(java.lang.String value)` Sets the value of the '`Meta Data Package Suffix`' attribute
`void` `setMultipleEditorPages(boolean value)` Sets the value of the '`Multiple Editor Pages`' attribute
`void` `setPrefix(java.lang.String value)` Sets the value of the '`Prefix`' attribute
`void` `setPresentationPackageSuffix(java.lang.String value)` Sets the value of the '`Presentation Package Suffix`' attribute
`void` `setProviderPackageSuffix(java.lang.String value)` Sets the value of the '`Provider Package Suffix`' attribute
`void` `setResource(GenResourceKind value)` Sets the value of the '`Resource`' attribute
`void` `setTestsPackageSuffix(java.lang.String value)` Sets the value of the '`Tests Package Suffix`' attribute
`void` `setUtilityPackageSuffix(java.lang.String value)` Sets the value of the '`Utility Package Suffix`' attribute

Methods inherited from interface org.eclipse.emf.codegen.ecore.genmodel.GenBase

`canGenerate, canGenerateEdit, canGenerateEditor, canGenerateSchema, canGenerateTests, capName, format, gen, genEdit, genEditor, generate, generate, generateEdit, generateEdit, generateEditor, generateEditor, generateSchema, generateSchema, generateTests, generateTests, genSchema, genTests, getCopyright, getDocumentation, getEcoreModelElement, getGenAnnotation, getGenAnnotations, hasCopyright, hasDocumentation, reconcile, safeName, uncapName, uncapPrefixedName`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Method Detail

### getPrefix

    java.lang.String getPrefix()

  Returns the value of the 'Prefix' attribute.

  Returns:
    the value of the 'Prefix' attribute.
  See Also:
    `setPrefix(String)`, `GenModelPackage.getGenPackage_Prefix()`

### setPrefix

    void setPrefix(java.lang.String value)

  Sets the value of the '`Prefix`' attribute.

  Parameters:
    `value` - the new value of the 'Prefix' attribute.
  See Also:
    `getPrefix()`

### getBasePackage

    java.lang.String getBasePackage()

  Returns the value of the 'Base Package' attribute.

  Returns:
    the value of the 'Base Package' attribute.
  See Also:
    `setBasePackage(String)`, `GenModelPackage.getGenPackage_BasePackage()`

### setBasePackage

    void setBasePackage(java.lang.String value)

  Sets the value of the '`Base Package`' attribute.

  Parameters:
    `value` - the new value of the 'Base Package' attribute.
  See Also:
    `getBasePackage()`

### getResource

    GenResourceKind getResource()

  Returns the value of the 'Resource' attribute. The literals are from the enumeration `GenResourceKind`.

  Returns:
    the value of the 'Resource' attribute.
  See Also:
    `GenResourceKind`, `setResource(GenResourceKind)`, `GenModelPackage.getGenPackage_Resource()`

### setResource

    void setResource(GenResourceKind value)

  Sets the value of the '`Resource`' attribute.

  Parameters:
    `value` - the new value of the 'Resource' attribute.
  See Also:
    `GenResourceKind`, `getResource()`

### isDisposableProviderFactory

    boolean isDisposableProviderFactory()

  Returns the value of the 'Disposable Provider Factory' attribute.

  Returns:
    the value of the 'Disposable Provider Factory' attribute.
  See Also:
    `setDisposableProviderFactory(boolean)`, `GenModelPackage.getGenPackage_DisposableProviderFactory()`

### setDisposableProviderFactory

    void setDisposableProviderFactory(boolean value)

  Sets the value of the '`Disposable Provider Factory`' attribute.

  Parameters:
    `value` - the new value of the 'Disposable Provider Factory' attribute.
  See Also:
    `isDisposableProviderFactory()`

### isAdapterFactory

    boolean isAdapterFactory()

  Returns the value of the 'Adapter Factory' attribute. The default value is `"true"`.

  Returns:
    the value of the 'Adapter Factory' attribute.
  See Also:
    `setAdapterFactory(boolean)`, `GenModelPackage.getGenPackage_AdapterFactory()`

### setAdapterFactory

    void setAdapterFactory(boolean value)

  Sets the value of the '`Adapter Factory`' attribute.

  Parameters:
    `value` - the new value of the 'Adapter Factory' attribute.
  See Also:
    `isAdapterFactory()`

### isLoadInitialization

    boolean isLoadInitialization()

  Returns the value of the 'Load Initialization' attribute.

  If true, the package meta-data will be initialized by loading it from a resource, instead of building it up programmatically. This should be used for large packasges, for which the generated code for building it would excede the 64k method limit.

  Returns:
    the value of the 'Load Initialization' attribute.
  See Also:
    `setLoadInitialization(boolean)`, `GenModelPackage.getGenPackage_LoadInitialization()`

### setLoadInitialization

    void setLoadInitialization(boolean value)

  Sets the value of the '`Load Initialization`' attribute.

  Parameters:
    `value` - the new value of the 'Load Initialization' attribute.
  See Also:
    `isLoadInitialization()`

### getInterfacePackageSuffix

    java.lang.String getInterfacePackageSuffix()

  Returns the value of the 'Interface Package Suffix' attribute. The default value is `""`.

  Returns:
    the value of the 'Interface Package Suffix' attribute.
  See Also:
    `setInterfacePackageSuffix(String)`, `GenModelPackage.getGenPackage_InterfacePackageSuffix()`

### setInterfacePackageSuffix

    void setInterfacePackageSuffix(java.lang.String value)

  Sets the value of the '`Interface Package Suffix`' attribute.

  Parameters:
    `value` - the new value of the 'Interface Package Suffix' attribute.
  See Also:
    `getInterfacePackageSuffix()`

### getMetaDataPackageSuffix

    java.lang.String getMetaDataPackageSuffix()

  Returns the value of the 'Meta Data Package Suffix' attribute. The default value is `""`.

  Returns:
    the value of the 'Meta Data Package Suffix' attribute.
  See Also:
    `setMetaDataPackageSuffix(String)`, `GenModelPackage.getGenPackage_MetaDataPackageSuffix()`

### setMetaDataPackageSuffix

    void setMetaDataPackageSuffix(java.lang.String value)

  Sets the value of the '`Meta Data Package Suffix`' attribute.

  Parameters:
    `value` - the new value of the 'Meta Data Package Suffix' attribute.
  See Also:
    `getMetaDataPackageSuffix()`

### getClassPackageSuffix

    java.lang.String getClassPackageSuffix()

  Returns the value of the 'Class Package Suffix' attribute. The default value is `"impl"`.

  Returns:
    the value of the 'Class Package Suffix' attribute.
  See Also:
    `setClassPackageSuffix(String)`, `GenModelPackage.getGenPackage_ClassPackageSuffix()`

### setClassPackageSuffix

    void setClassPackageSuffix(java.lang.String value)

  Sets the value of the '`Class Package Suffix`' attribute.

  Parameters:
    `value` - the new value of the 'Class Package Suffix' attribute.
  See Also:
    `getClassPackageSuffix()`

### getUtilityPackageSuffix

    java.lang.String getUtilityPackageSuffix()

  Returns the value of the 'Utility Package Suffix' attribute. The default value is `"util"`.

  Returns:
    the value of the 'Utility Package Suffix' attribute.
  See Also:
    `setUtilityPackageSuffix(String)`, `GenModelPackage.getGenPackage_UtilityPackageSuffix()`

### setUtilityPackageSuffix

    void setUtilityPackageSuffix(java.lang.String value)

  Sets the value of the '`Utility Package Suffix`' attribute.

  Parameters:
    `value` - the new value of the 'Utility Package Suffix' attribute.
  See Also:
    `getUtilityPackageSuffix()`

### getProviderPackageSuffix

    java.lang.String getProviderPackageSuffix()

  Returns the value of the 'Provider Package Suffix' attribute. The default value is `"provider"`.

  Returns:
    the value of the 'Provider Package Suffix' attribute.
  See Also:
    `setProviderPackageSuffix(String)`, `GenModelPackage.getGenPackage_ProviderPackageSuffix()`

### setProviderPackageSuffix

    void setProviderPackageSuffix(java.lang.String value)

  Sets the value of the '`Provider Package Suffix`' attribute.

  Parameters:
    `value` - the new value of the 'Provider Package Suffix' attribute.
  See Also:
    `getProviderPackageSuffix()`

### getPresentationPackageSuffix

    java.lang.String getPresentationPackageSuffix()

  Returns the value of the 'Presentation Package Suffix' attribute. The default value is `"presentation"`.

  Returns:
    the value of the 'Presentation Package Suffix' attribute.
  See Also:
    `setPresentationPackageSuffix(String)`, `GenModelPackage.getGenPackage_PresentationPackageSuffix()`

### setPresentationPackageSuffix

    void setPresentationPackageSuffix(java.lang.String value)

  Sets the value of the '`Presentation Package Suffix`' attribute.

  Parameters:
    `value` - the new value of the 'Presentation Package Suffix' attribute.
  See Also:
    `getPresentationPackageSuffix()`

### getTestsPackageSuffix

    java.lang.String getTestsPackageSuffix()

  Returns the value of the 'Tests Package Suffix' attribute. The default value is `"tests"`.

  Returns:
    the value of the 'Tests Package Suffix' attribute.
  See Also:
    `setTestsPackageSuffix(String)`, `GenModelPackage.getGenPackage_TestsPackageSuffix()`

### setTestsPackageSuffix

    void setTestsPackageSuffix(java.lang.String value)

  Sets the value of the '`Tests Package Suffix`' attribute.

  Parameters:
    `value` - the new value of the 'Tests Package Suffix' attribute.
  See Also:
    `getTestsPackageSuffix()`

### isGenerateExampleClass

    boolean isGenerateExampleClass()

  Returns the value of the 'Generate Example Class' attribute. The default value is `"true"`.

  Returns:
    the value of the 'Generate Example Class' attribute.
  See Also:
    `setGenerateExampleClass(boolean)`, `GenModelPackage.getGenPackage_GenerateExampleClass()`

### setGenerateExampleClass

    void setGenerateExampleClass(boolean value)

  Sets the value of the '`Generate Example Class`' attribute.

  Parameters:
    `value` - the new value of the 'Generate Example Class' attribute.
  See Also:
    `isGenerateExampleClass()`

### isLiteralsInterface

    boolean isLiteralsInterface()

  Returns the value of the 'Literals Interface' attribute. The default value is `"true"`.

  Returns:
    the value of the 'Literals Interface' attribute.
  See Also:
    `setLiteralsInterface(boolean)`, `GenModelPackage.getGenPackage_LiteralsInterface()`

### setLiteralsInterface

    void setLiteralsInterface(boolean value)

  Sets the value of the '`Literals Interface`' attribute.

  Parameters:
    `value` - the new value of the 'Literals Interface' attribute.
  See Also:
    `isLiteralsInterface()`

### isDataTypeConverters

    boolean isDataTypeConverters()

  Returns the value of the 'Data Type Converters' attribute.

  Returns:
    the value of the 'Data Type Converters' attribute.
  See Also:
    `setDataTypeConverters(boolean)`, `GenModelPackage.getGenPackage_DataTypeConverters()`

### setDataTypeConverters

    void setDataTypeConverters(boolean value)

  Sets the value of the '`Data Type Converters`' attribute.

  Parameters:
    `value` - the new value of the 'Data Type Converters' attribute.
  See Also:
    `isDataTypeConverters()`

### isMultipleEditorPages

    boolean isMultipleEditorPages()

  Returns the value of the 'Multiple Editor Pages' attribute. The default value is `"true"`.

  Returns:
    the value of the 'Multiple Editor Pages' attribute.
  See Also:
    `setMultipleEditorPages(boolean)`, `GenModelPackage.getGenPackage_MultipleEditorPages()`

### setMultipleEditorPages

    void setMultipleEditorPages(boolean value)

  Sets the value of the '`Multiple Editor Pages`' attribute.

  Parameters:
    `value` - the new value of the 'Multiple Editor Pages' attribute.
  See Also:
    `isMultipleEditorPages()`

### isGenerateModelWizard

    boolean isGenerateModelWizard()

  Returns the value of the 'Generate Model Wizard' attribute. The default value is `"true"`.

  Returns:
    the value of the 'Generate Model Wizard' attribute.
  See Also:
    `setGenerateModelWizard(boolean)`, `GenModelPackage.getGenPackage_GenerateModelWizard()`

### setGenerateModelWizard

    void setGenerateModelWizard(boolean value)

  Sets the value of the '`Generate Model Wizard`' attribute.

  Parameters:
    `value` - the new value of the 'Generate Model Wizard' attribute.
  See Also:
    `isGenerateModelWizard()`

### isExtensibleProviderFactory

    boolean isExtensibleProviderFactory()

  Returns the value of the 'Extensible Provider Factory' attribute.

  Returns:
    the value of the 'Extensible Provider Factory' attribute.
  Since:
    2.4
  See Also:
    `setExtensibleProviderFactory(boolean)`, `GenModelPackage.getGenPackage_ExtensibleProviderFactory()`

### setExtensibleProviderFactory

    void setExtensibleProviderFactory(boolean value)

  Sets the value of the '`Extensible Provider Factory`' attribute.

  Parameters:
    `value` - the new value of the 'Extensible Provider Factory' attribute.
  See Also:
    `isExtensibleProviderFactory()`

### isChildCreationExtenders

    boolean isChildCreationExtenders()

  Returns the value of the 'Child Creation Extenders' attribute.

  Returns:
    the value of the 'Child Creation Extenders' attribute.
  Since:
    2.4
  See Also:
    `setChildCreationExtenders(boolean)`, `GenModelPackage.getGenPackage_ChildCreationExtenders()`

### setChildCreationExtenders

    void setChildCreationExtenders(boolean value)

  Sets the value of the '`Child Creation Extenders`' attribute.

  Parameters:
    `value` - the new value of the 'Child Creation Extenders' attribute.
  See Also:
    `isChildCreationExtenders()`

### getContentTypeIdentifier

    java.lang.String getContentTypeIdentifier()

  Returns the value of the 'Content Type Identifier' attribute.

  A content type identifier against which to register the resource factory for this package.

  Returns:
    the value of the 'Content Type Identifier' attribute.
  Since:
    2.4
  See Also:
    `setContentTypeIdentifier(String)`, `GenModelPackage.getGenPackage_ContentTypeIdentifier()`

### setContentTypeIdentifier

    void setContentTypeIdentifier(java.lang.String value)

  Sets the value of the '`Content Type Identifier`' attribute.

  Parameters:
    `value` - the new value of the 'Content Type Identifier' attribute.
  See Also:
    `getContentTypeIdentifier()`

### getFileExtensions

    java.lang.String getFileExtensions()

  Returns the value of the 'File Extensions' attribute.

  The file extensions against which to register the resource factory for this package. Multiple extensions can be specified as a comma-separated list, but only if this package defines a `content type`. This will always return a non-null string. The default (returned after the attribute is set to null) is based on the `getPrefix()`.

  Returns:
    the value of the 'File Extensions' attribute.
  Since:
    2.4
  See Also:
    `setFileExtensions(String)`, `GenModelPackage.getGenPackage_FileExtensions()`

### setFileExtensions

    void setFileExtensions(java.lang.String value)

  Sets the value of the '`File Extensions`' attribute.

  Parameters:
    `value` - the new value of the 'File Extensions' attribute.
  See Also:
    `getFileExtensions()`

### getEcorePackage

    EPackage getEcorePackage()

  Returns the value of the 'Ecore Package' reference.

  Returns:
    the value of the 'Ecore Package' reference.
  See Also:
    `setEcorePackage(EPackage)`, `GenModelPackage.getGenPackage_EcorePackage()`

### setEcorePackage

    void setEcorePackage(EPackage value)

  Sets the value of the '`Ecore Package`' reference.

  Parameters:
    `value` - the new value of the 'Ecore Package' reference.
  See Also:
    `getEcorePackage()`

### getGenModel

    GenModel getGenModel()

  Returns the value of the 'Gen Model' container reference. It is bidirectional and its opposite is '`Gen Packages`'.

  Specified by:
    `getGenModel` in interface `GenBase`
  Returns:
    the value of the 'Gen Model' container reference.
  See Also:
    `setGenModel(GenModel)`, `GenModelPackage.getGenPackage_GenModel()`, `GenModel.getGenPackages()`

### setGenModel

    void setGenModel(GenModel value)

  Sets the value of the '`Gen Model`' container reference.

  Parameters:
    `value` - the new value of the 'Gen Model' container reference.
  See Also:
    `getGenModel()`

### getGenEnums

    EList<GenEnum> getGenEnums()

  Returns the value of the 'Gen Enums' containment reference list. The list contents are of type `GenEnum`.

  Returns:
    the value of the 'Gen Enums' containment reference list.
  See Also:
    `GenModelPackage.getGenPackage_GenEnums()`

### getGenDataTypes

    EList<GenDataType> getGenDataTypes()

  Returns the value of the 'Gen Data Types' containment reference list. The list contents are of type `GenDataType`.

  Returns:
    the value of the 'Gen Data Types' containment reference list.
  See Also:
    `GenModelPackage.getGenPackage_GenDataTypes()`

### getGenClasses

    EList<GenClass> getGenClasses()

  Returns the value of the 'Gen Classes' containment reference list. The list contents are of type `GenClass`.

  Returns:
    the value of the 'Gen Classes' containment reference list.
  See Also:
    `GenModelPackage.getGenPackage_GenClasses()`

### getNestedGenPackages

    EList<GenPackage> getNestedGenPackages()

  Returns the value of the 'Nested Gen Packages' containment reference list. The list contents are of type `GenPackage`.

  Returns:
    the value of the 'Nested Gen Packages' containment reference list.
  See Also:
    `GenModelPackage.getGenPackage_NestedGenPackages()`

### getGenClassifiers

    EList<GenClassifier> getGenClassifiers()

  Returns the value of the 'Gen Classifiers' reference list. The list contents are of type `GenClassifier`. It is bidirectional and its opposite is '`Gen Package`'.

  Returns:
    the value of the 'Gen Classifiers' reference list.
  See Also:
    `GenModelPackage.getGenPackage_GenClassifiers()`, `GenClassifier.getGenPackage()`

### getInterfacePackageName

    java.lang.String getInterfacePackageName()

### getReflectionPackageName

    java.lang.String getReflectionPackageName()

### getReflectionClassPackageName

    java.lang.String getReflectionClassPackageName()

### getClassPackageName

    java.lang.String getClassPackageName()

### getUtilitiesPackageName

    java.lang.String getUtilitiesPackageName()

### getTestsPackageName

    java.lang.String getTestsPackageName()

### getNSName

    java.lang.String getNSName()

### getNSURI

    java.lang.String getNSURI()

### getPackageName

    java.lang.String getPackageName()

### getQualifiedPackageName

    java.lang.String getQualifiedPackageName()

### getBasicPackageName

    java.lang.String getBasicPackageName()

  Returns the name of the single package class generated when interfaces are suppressed. It is simply the package `prefix`, with "Package" appended. This method is analagous to `getFactoryName()` and would be called `getPackageName()` if that name were not already taken.

  Since:
    2.5

### getUncapPackageName

    java.lang.String getUncapPackageName()

  Since:
    2.5

### getPackageInterfaceName

    java.lang.String getPackageInterfaceName()

### getQualifiedPackageInterfaceName

    java.lang.String getQualifiedPackageInterfaceName()

### getImportedPackageInterfaceName

    java.lang.String getImportedPackageInterfaceName()

### getUncapPackageInterfaceName

    @Deprecated
    java.lang.String getUncapPackageInterfaceName()

  Deprecated. Use `getUncapFactoryName()`, which won't change with the interface name pattern, instead.

### getPackageClassName

    java.lang.String getPackageClassName()

### getQualifiedPackageClassName

    java.lang.String getQualifiedPackageClassName()

### getImportedPackageClassName

    java.lang.String getImportedPackageClassName()

### getFactoryName

    java.lang.String getFactoryName()

  Returns the name of the single factory class generated when interfaces are suppressed. It is simply the package `prefix`, with "Factory" appended.

  Since:
    2.5

### getUncapFactoryName

    java.lang.String getUncapFactoryName()

  Since:
    2.5

### getFactoryInterfaceName

    java.lang.String getFactoryInterfaceName()

### getQualifiedFactoryInterfaceName

    java.lang.String getQualifiedFactoryInterfaceName()

### getImportedFactoryInterfaceName

    java.lang.String getImportedFactoryInterfaceName()

### getUncapFactoryInterfaceName

    @Deprecated
    java.lang.String getUncapFactoryInterfaceName()

  Deprecated. Use `getUncapFactoryName()`, which won't change with the interface name pattern, instead.

### getFactoryClassName

    java.lang.String getFactoryClassName()

### getQualifiedFactoryClassName

    java.lang.String getQualifiedFactoryClassName()

### getImportedFactoryClassName

    java.lang.String getImportedFactoryClassName()

### getFactoryInstanceName

    java.lang.String getFactoryInstanceName()

### getQualifiedFactoryInstanceAccessor

    java.lang.String getQualifiedFactoryInstanceAccessor()

### getQualifiedEFactoryInstanceAccessor

    java.lang.String getQualifiedEFactoryInstanceAccessor()

### getQualifiedEFactoryInternalInstanceAccessor

    java.lang.String getQualifiedEFactoryInternalInstanceAccessor()

### getAdapterFactoryClassName

    java.lang.String getAdapterFactoryClassName()

### getQualifiedAdapterFactoryClassName

    java.lang.String getQualifiedAdapterFactoryClassName()

### getImportedAdapterFactoryClassName

    java.lang.String getImportedAdapterFactoryClassName()

### getUncapAdapterFactoryClassName

    java.lang.String getUncapAdapterFactoryClassName()

### getSwitchClassName

    java.lang.String getSwitchClassName()

### getQualifiedSwitchClassName

    java.lang.String getQualifiedSwitchClassName()

### getValidatorClassName

    java.lang.String getValidatorClassName()

### getQualifiedValidatorClassName

    java.lang.String getQualifiedValidatorClassName()

### getImportedValidatorClassName

    java.lang.String getImportedValidatorClassName()

### getTestSuiteClassName

    java.lang.String getTestSuiteClassName()

### getQualifiedTestSuiteClassName

    java.lang.String getQualifiedTestSuiteClassName()

### getImportedTestSuiteClassName

    java.lang.String getImportedTestSuiteClassName()

### getExampleClassName

    java.lang.String getExampleClassName()

### getQualifiedExampleClassName

    java.lang.String getQualifiedExampleClassName()

### getQualifiedXMLProcessorClassName

    java.lang.String getQualifiedXMLProcessorClassName()

### getXMLProcessorClassName

    java.lang.String getXMLProcessorClassName()

### getImportedXMLProcessorBaseClassName

    java.lang.String getImportedXMLProcessorBaseClassName()

### getAllGenDataTypes

    java.util.List<GenDataType> getAllGenDataTypes()

### getOrderedGenClasses

    java.util.List<GenClass> getOrderedGenClasses()

  Returns the list of GenClasses in the GenPackage, ordered such that a class always follows all of the classes it extends. Appropriate for use in package interface to declare feature constants, which will depend on (and hence must follow) constants for the extended class.

### getOrderedGenClassifiers

    java.util.List<GenClassifier> getOrderedGenClassifiers()

### getClassifierID

    java.lang.String getClassifierID(GenClassifier genClassifier)

### getClassifierValue

    int getClassifierValue(GenClassifier genClassifier)

### getLocalClassifierIndex

    int getLocalClassifierIndex(GenClassifier genClassifier)

### getPackageSimpleDependencies

    java.util.List<GenPackage> getPackageSimpleDependencies()

### getPackageInterDependencies

    java.util.List<GenPackage> getPackageInterDependencies()

### getPackageLoadInterDependencies

    java.util.List<GenPackage> getPackageLoadInterDependencies()

### getPackageBuildInterDependencies

    java.util.List<GenPackage> getPackageBuildInterDependencies()

### getPackageInitializationDependencies

    java.util.List<GenPackage> getPackageInitializationDependencies()

### getPackageInstanceVariable

    java.lang.String getPackageInstanceVariable(GenPackage genPackage)

### getSubGenPackages

    java.util.List<GenPackage> getSubGenPackages()

  Returns a list of those nestedGenPackages for which hasClassifiers() is true.

### getSuperGenPackage

    GenPackage getSuperGenPackage()

  Returns the closest GenPackage-typed container for which hasClassifiers() is true, or null if there is none.

### getRootGenPackage

    GenPackage getRootGenPackage()

  Returns the top-most GenPackage-typed container for which hasClassifiers() is true, which may be this GenPackage, itself.

### isLoadingInitialization

    boolean isLoadingInitialization()

  Returns true if this is a root package that requires, or has a direct or indirect subpackage that requires, load initialization.

### isLoadedInitialization

    boolean isLoadedInitialization()

  Returns true if this package's root, which may be itself, requires, or has a subpackage that requires, load initialization.

### isEcorePackage

    boolean isEcorePackage()

### hasInterfaceImplConflict

    boolean hasInterfaceImplConflict()

### hasJavaLangConflict

    boolean hasJavaLangConflict()

### getJavaLangConflicts

    java.util.List<java.lang.String> getJavaLangConflicts()

### hasClassifiers

    boolean hasClassifiers()

### hasClassifiers

    boolean hasClassifiers(boolean traverseNestedPackages)

### getAllSwitchGenClasses

    java.util.List<GenClass> getAllSwitchGenClasses()

### getClassUniqueName

    java.lang.String getClassUniqueName(GenClass genClass)

### getAllValidatorBaseGenPackages

    java.util.List<GenPackage> getAllValidatorBaseGenPackages()

### getValidatorPackageUniqueSafeName

    java.lang.String getValidatorPackageUniqueSafeName(GenPackage genPackage)

### initialize

    void initialize(EPackage ePackage)

### prepareCache

    void prepareCache()

### clearCache

    void clearCache()

### generateSchema

    @Deprecated
    void generateSchema()

  Deprecated. In EMF 2.2, schema generation is properly done via a model exporter. This method will be removed after 2.2.

### getProviderPackageName

    java.lang.String getProviderPackageName()

### getPresentationPackageName

    java.lang.String getPresentationPackageName()

### getItemProviderAdapterFactoryClassName

    java.lang.String getItemProviderAdapterFactoryClassName()

### getQualifiedItemProviderAdapterFactoryClassName

    java.lang.String getQualifiedItemProviderAdapterFactoryClassName()

### getImportedItemProviderAdapterFactoryClassName

    java.lang.String getImportedItemProviderAdapterFactoryClassName()

### getEditorClassName

    java.lang.String getEditorClassName()

### getQualifiedEditorClassName

    java.lang.String getQualifiedEditorClassName()

### getImportedEditorClassName

    java.lang.String getImportedEditorClassName()

### getModelWizardClassName

    java.lang.String getModelWizardClassName()

### getQualifiedModelWizardClassName

    java.lang.String getQualifiedModelWizardClassName()

### getImportedModelWizardClassName

    java.lang.String getImportedModelWizardClassName()

### getActionBarContributorClassName

    java.lang.String getActionBarContributorClassName()

### getQualifiedActionBarContributorClassName

    java.lang.String getQualifiedActionBarContributorClassName()

### getImportedActionBarContributorClassName

    java.lang.String getImportedActionBarContributorClassName()

### getAdapterFactoryDelegateName

    java.lang.String getAdapterFactoryDelegateName(GenPackage genDelegate)

### getUncapAdapterFactoryDelegateName

    java.lang.String getUncapAdapterFactoryDelegateName(GenPackage genDelegate)

### getEditPluginClassName

    java.lang.String getEditPluginClassName()

### getQualifiedEditPluginClassName

    java.lang.String getQualifiedEditPluginClassName()

### getImportedEditPluginClassName

    java.lang.String getImportedEditPluginClassName()

### getEditorPluginClassName

    java.lang.String getEditorPluginClassName()

### getQualifiedEditorPluginClassName

    java.lang.String getQualifiedEditorPluginClassName()

### getImportedEditorPluginClassName

    java.lang.String getImportedEditorPluginClassName()

### getModelIconFileName

    java.lang.String getModelIconFileName()

### getModelWizardIconFileName

    java.lang.String getModelWizardIconFileName()

### getAllGenFeatures

    java.util.List<GenFeature> getAllGenFeatures()

### getAdapterDelegatePackages

    java.util.List<GenPackage> getAdapterDelegatePackages()

### getAdapterDelegateSuperClasses

    java.util.List<GenClass> getAdapterDelegateSuperClasses()

### hasStatefulProvider

    boolean hasStatefulProvider()

### getModelInfo

    java.lang.String getModelInfo()

### reconcile

    boolean reconcile(GenPackage oldGenPackageVersion)

### getAnnotationSources

    java.util.List<java.lang.String> getAnnotationSources()

### getAnnotationSourceIdentifier

    java.lang.String getAnnotationSourceIdentifier(java.lang.String annotationSource)

### getAllAnnotations

    java.util.List<EAnnotation> getAllAnnotations()

### getAnnotatedModelElementAccessor

    java.lang.String getAnnotatedModelElementAccessor(EAnnotation eAnnotation)

### getAllNestedAnnotations

    java.util.List<EAnnotation> getAllNestedAnnotations(EAnnotation eAnnotation)

### getReferenceData

    java.util.List<GenPackage.AnnotationReferenceData> getReferenceData(EAnnotation eAnnotation)

  Since:
    2.5

### getResourceClassName

    java.lang.String getResourceClassName()

### getQualifiedResourceClassName

    java.lang.String getQualifiedResourceClassName()

### getImportedResourceClassName

    java.lang.String getImportedResourceClassName()

### getImportedResourceBaseClassName

    java.lang.String getImportedResourceBaseClassName()

### getResourceFactoryClassName

    java.lang.String getResourceFactoryClassName()

### getQualifiedResourceFactoryClassName

    java.lang.String getQualifiedResourceFactoryClassName()

### getImportedResourceFactoryClassName

    java.lang.String getImportedResourceFactoryClassName()

### getImportedResourceFactoryBaseClassName

    java.lang.String getImportedResourceFactoryBaseClassName()

### hasXMLMap

    boolean hasXMLMap()

### hasDocumentRoot

    boolean hasDocumentRoot()

### getDocumentRoot

    GenClass getDocumentRoot()

### hasExtendedMetaData

    boolean hasExtendedMetaData()

### hasTargetNamespace

    boolean hasTargetNamespace()

### hasConstraints

    boolean hasConstraints()

### getSerializedPackageFilename

    java.lang.String getSerializedPackageFilename()

### getProviderSupportedTypes

    java.util.List<java.lang.String> getProviderSupportedTypes()

### getRootClass

    GenClass getRootClass()

### getRootFeature

    GenFeature getRootFeature()

### hasConcreteClasses

    boolean hasConcreteClasses()

### hasTests

    boolean hasTests()

### getExtendedChildCreationData

    java.util.Map<GenPackage,java.util.Map<GenClass,java.util.List<GenClass.ChildCreationData>>> getExtendedChildCreationData()

  Returns a nested map structure describing the child creation extensions that this package provides to other packages. The result maps other packages to their classes that have child creation extension provided by this package. Each inner map maps from the class to the list of child creation data for these extensions.

  Since:
    2.4

### getChildCreationExtenderName

    java.lang.String getChildCreationExtenderName(GenPackage genPackage)

  Since:
    2.4

### isContentType

    boolean isContentType()

  Returns whether the package should define a content type.

  Since:
    2.4
  See Also:
    `getContentTypeIdentifier()`

### getQualifiedContentTypeIdentifier

    java.lang.String getQualifiedContentTypeIdentifier()

  Returns the qualified content type identifier. Usually, this is the same as `getContentTypeIdentifier()`; however, if that value is unqualified, this will add the implicit model plug-in ID qualification.

  Since:
    2.4
  See Also:
    `getContentTypeIdentifier()`

### isXMIResource

    boolean isXMIResource()

  Returns whether the package's `resource` produces an XMI serialization.

  Since:
    2.4
  See Also:
    `getResource()`

### getQualifiedEffectiveResourceFactoryClassName

    java.lang.String getQualifiedEffectiveResourceFactoryClassName()

  Returns the package's `resource factory class name`, or the framework's default XMI resource factory class name if no `resource` will be generated for the package.

  Since:
    2.4
  See Also:
    `getQualifiedResourceFactoryClassName()`, `getResource()`

### isMultipleFileExtensions

    boolean isMultipleFileExtensions()

  Returns whether the model supports multiple file extensions, based both on the specified `extensions` and the use of a `content type`.

  See Also:
    `getFileExtensions()`, `isContentType()`

### getFileExtension

    java.lang.String getFileExtension()

  Returns the first `file extension` in the comma-separated list.

  Since:
    2.4
  See Also:
    `getFileExtensions()`

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.